Codeforces_733C
1 second
256 megabytes
standard input
standard output
There was an epidemic in Monstropolis and all monsters became sick. To recover, all monsters lined up in queue for an appointment to the only doctor in the city.
Soon, monsters became hungry and began to eat each other.
One monster can eat other monster if its weight is strictly greater than the weight of the monster being eaten, and they stand in the queue next to each other. Monsters eat each other instantly. There are no monsters which are being eaten at the same moment. After the monster A eats the monster B, the weight of the monster A increases by the weight of the eaten monster B. In result of such eating the length of the queue decreases by one, all monsters after the eaten one step forward so that there is no empty places in the queue again. A monster can eat several monsters one after another. Initially there were n monsters in the queue, the i-th of which had weight ai.
For example, if weights are [1, 2, 2, 2, 1, 2] (in order of queue, monsters are numbered from 1 to 6 from left to right) then some of the options are:
- the first monster can't eat the second monster because a1 = 1 is not greater than a2 = 2;
- the second monster can't eat the third monster because a2 = 2 is not greater than a3 = 2;
- the second monster can't eat the fifth monster because they are not neighbors;
- the second monster can eat the first monster, the queue will be transformed to [3, 2, 2, 1, 2].
After some time, someone said a good joke and all monsters recovered. At that moment there were k (k ≤ n) monsters in the queue, the j-th of which had weight bj. Both sequences (a and b) contain the weights of the monsters in the order from the first to the last.
You are required to provide one of the possible orders of eating monsters which led to the current queue, or to determine that this could not happen. Assume that the doctor didn't make any appointments while monsters were eating each other.
The first line contains single integer n (1 ≤ n ≤ 500) — the number of monsters in the initial queue.
The second line contains n integers a1, a2, ..., an (1 ≤ ai ≤ 106) — the initial weights of the monsters.
The third line contains single integer k (1 ≤ k ≤ n) — the number of monsters in the queue after the joke.
The fourth line contains k integers b1, b2, ..., bk (1 ≤ bj ≤ 5·108) — the weights of the monsters after the joke.
Monsters are listed in the order from the beginning of the queue to the end.
In case if no actions could lead to the final queue, print "NO" (without quotes) in the only line.
Otherwise print "YES" (without quotes) in the first line. In the next n - k lines print actions in the chronological order. In each line print x — the index number of the monster in the current queue which eats and, separated by space, the symbol 'L' if the monster which stays the x-th in the queue eats the monster in front of him, or 'R' if the monster which stays the x-th in the queue eats the monster behind him. After each eating the queue is enumerated again.
When one monster eats another the queue decreases. If there are several answers, print any of them.
6
1 2 2 2 1 2
2
5 5
YES
2 L
1 R
4 L
3 L
5
1 2 3 4 5
1
15
YES
5 L
4 L
3 L
2 L
5
1 1 1 3 3
3
2 1 6 题意:n个数,如果一个数num[i]大于它前面的数num[i-1],那么num[i]可以吞掉num[i-1],整个数组的长度减1;如果num[i]>num[i+1],那么num[i]可以吞掉num[i+1],数组长度减1。
给定一个最终状态的数组,问初始状态能否转化为最终状态,并输出路径。 思路:若能转化,那么初态数组中的一段连续的数可以合并成最终状态数组中对应的一个数。找到一个最大的且位置合适的数,如果左边的数比它小,那么从这个数吃到最左,再吃到最右;
如果右边的数比它小,那么从这个数吃到最右边,再吃到最左边。这种模拟有很多细节要注意,wa哭了。。。 注:
1.可能初态中没有一段数对应终态中的一个数。
2.有可能匹配完了过后,初态中还有数。
3.直接向右吃时,要注意此时最大的数一定要是最右边的。
4.处理完一段后,后面的段的坐标要相应的变化。 代码跟屎一样乱。。。
#include<iostream>
#include<cstdio>
using namespace std;
#define N 505 struct Segment
{
int l,r;
int maxn;
}seg[N];
int numb[N],numc[N];
int main()
{
int nb,nc;
while(scanf("%d",&nb)!=EOF)
{
for(int i=;i<=nb;i++)
scanf("%d",&numb[i]);
scanf("%d",&nc);
for(int i=;i<=nc;i++)
scanf("%d",&numc[i]);
int cu=,cnt=,maxn=,mloc=,head=,tail=,sum=,flag=;
for(int i=;i<=nb;i++)
{
if(cu>nc)
{
flag=;
break;
}
if(numb[i]>maxn)
{
mloc=i;
maxn=numb[i];
}
sum+=numb[i];
tail++;
if(sum==numc[cu])
{
Segment s;
s.l=head;
s.r=tail-;
s.maxn=mloc;
seg[cnt++]=s;
head=tail=i+;
maxn=;
cu++;
sum=;
}
}
if(cu<nc+)
flag=;
int eat[N];
char eatc[N];
int cntt=,bef=;
for(int i=;i<cnt;i++)
{
if(flag==)
break;
if(seg[i].l==seg[i].r)
continue;
int loc=seg[i].maxn;
if(loc->=seg[i].l&&numb[loc-]<numb[loc])
{
for(int j=loc-bef;j>seg[i].l-bef;j--)
{
eat[cntt]=j;
eatc[cntt++]='L';
}
for(int j=seg[i].l-bef;j<seg[i].l-bef+seg[i].r-loc;j++)
{
eat[cntt]=seg[i].l-bef;
eatc[cntt++]='R';
}
}
else if(loc+<=seg[i].r&&numb[loc+]<=numb[loc])
{
while(numb[loc+]==numb[loc])
{
loc++;
if(loc==seg[i].r)
break;
}
if(numb[loc-]>=numb[loc]&&loc==seg[i].r)
{
flag=;
break;
}
for(int j=loc-bef;j<seg[i].r-bef;j++)
{
eat[cntt]=loc-bef;
eatc[cntt++]='R';
} for(int j=loc-bef;j>seg[i].l-bef;j--)
{
eat[cntt]=j;
eatc[cntt++]='L';
}
}
else
{
flag=;
break;
}
bef=seg[i].r-i;
}
if(flag)
{
printf("YES\n");
for(int i=;i<cntt;i++)
{
printf("%d %c\n",eat[i],eatc[i]);
}
}
else
printf("NO\n");
}
return ;
}
Codeforces_733C的更多相关文章
随机推荐
- 用 Arduino Uno 给 Arduino Mini(Pro)烧录程序
用 Arduino Uno 给 Arduino Mini(Pro)烧录程序 准备 Arduino Uno Arduino Mini(Pro) 杜邦线若干 接线 首先去掉 Arduino 上的芯片ATM ...
- java 反射和暴力反射 两个DEMO
</pre><pre code_snippet_id="402084" snippet_file_name="blog_20140622_5_93502 ...
- com.opensymphony.xwork2.inject.DependencyException: com.opensymphony.xwork2.inject.ContainerImpl$Mis
为什么会出现这个错误? 我使用了Maven配置Struts,所以改动Struts配置文件的默认路径,例如以下: <!-- 配置struts --> <filter> <f ...
- LeetCode 720. Longest Word in Dictionary (字典里最长的单词)
Given a list of strings words representing an English Dictionary, find the longest word in words tha ...
- 关于SVG图片不显示
SVG图片在本地调试时.可以正常显示.可是上传到server或者虚拟主机以后不显示. 这个问题该怎么解决呢? 两种解决的方法: 第一种:在server上 IIS 或者其它Webserver上 加入 S ...
- 一个APP爆炸的时代,假设没有wifi
我们每天都离不开的微信,又传来了一个新消息.你造?微信公众平台新增了设备功能.眼下可支持可穿戴设备,将来呢,前景不可限量!能够想象,"后果"是我们越来越离不开微信,依附于它.这样的 ...
- C++中stringstream ostringstream istringstream使用方式
C++引入了ostringstream.istringstream.stringstream这三个类,要使用他们创建对象就必须包括sstream.h头文件. istringstream类用于运行C++ ...
- 浅谈JVM内存模型
JAVA虚拟机在执行JAVA程序的时候,会把它管理的内存分成若干不同的数据区域,每个区域都有各自的用途.目前大致把JVM内存模型划分为五个区域:程序计数器,虚拟机栈,本地方法栈,堆和方法区. 程序计数 ...
- 【POJ 3974】 Palindrome
[题目链接] http://poj.org/problem?id=3974 [算法] 解法1 : 字符串哈希 我们可以分别考虑奇回文子串和偶回文子串,从前往后扫描字符串,然后二分答案,检验可以用哈希 ...
- Makefile 实际用例分析(三) ------- 是用GUN automake 处理自己的工程
前面两篇已经说过了自己怎么去为一个工程写makefile: 第一篇 第二篇 现在这一篇说的是怎么使用GNU的工具去写一个符合开源标准的Makefile呢! 首先我觉你应该参考: Automake Au ...